#include<iostream>
#include<string>
#include "Zamestnanec3.h"
using namespace std;

class Zamestnanec1
{
//private:
	string jmeno="";
	string prijmeni="";
	unsigned int plat;
	const int id = 1000;

	string jmenoAprijmeni() const
	{
		return jmeno + " " + prijmeni;
	}
public:
	// konstruktor bez parametru, s iniciacni casti:
	Zamestnanec1() : jmeno("Borivoj"), prijmeni("Novak"), id(78)
	{
		cout << "konstruktor bez parametru" << endl;
		//jmeno = "Borivoj";
		//prijmeni = "Novak";
		plat = 30000;
	}
	// konstruktor s parametry:
	Zamestnanec1(const string &jmeno, string prijmeni="Novotny", unsigned int plat=78000) : jmeno(jmeno), id(17)
	{
		cout << "konstruktor se tremi parametry" << endl;
		//this->jmeno = jmeno;
		this->prijmeni = prijmeni;
		if (plat < 10000 || plat > 100000)
			plat = 50000;
		else
			this->plat = plat;
	}
	// destruktor 
	~Zamestnanec1()
	{
		cout << "konec: ";
		vypis();
	}

	void nastavJmeno(const string &jmeno) // setName
	{
		this->jmeno = jmeno;
	}
	void nastavPrijmeni(const string &_prijmeni) // setName
	{
		prijmeni = _prijmeni;
	}
	void nastavPlat(unsigned int plat) // setName
	{
		if (plat < 10000 || plat > 100000)
			plat = 50000;
		this->plat = plat;
	}
	void nastav(const string &jmeno, const string &prijmeni, unsigned int plat)
	{
		this->jmeno = jmeno;
		this->prijmeni = prijmeni;
		if (plat < 10000 || plat > 100000)
			plat = 50000;
		else
			this->plat = plat;
	}
	string vratJmeno() const // getName
	{
		return jmeno;
	}

	void vypis() const
	{
		cout << "metoda: ";
		//cout << jmenoAprijmeni() << ' ' << plat << endl;
		cout << this->id << " ";
		cout << this->jmenoAprijmeni() << ' ' << this->plat << endl;
		//cout << jmeno << " " << prijmeni << ' ' << plat <<  endl;
		//cout << this->jmeno << " " << this->prijmeni << ' ' << plat << endl;
	}
	friend class Zamestnanec2;
	friend void vypis(const Zamestnanec1 &z);
	friend float premie(const Zamestnanec1 &z)
	{
		return z.plat * 0.1;
	}
};

void vypis(const Zamestnanec1 &z)
{
	cout << z.jmenoAprijmeni() << " " << z.plat << endl;
}

class Zamestnanec2
{
private:
	string jmeno;
	string prijmeni;
	unsigned int plat;

	string jmenoAprijmeni();
public:
	void vypis();
};

string Zamestnanec2::jmenoAprijmeni()
{
	return jmeno + " " + prijmeni;
}

void Zamestnanec2::vypis()
{
	cout << "metoda: ";
	//cout << jmenoAprijmeni() << ' ' << plat << endl;
	cout << this->jmenoAprijmeni() << ' ' << this->plat << endl;
	//cout << jmeno << " " << prijmeni << ' ' << plat <<  endl;
	//cout << this->jmeno << " " << this->prijmeni << ' ' << plat << endl;
}


class Vector
{
	float *a;
	const int n=0;
public:
	Vector(int _n) : n(_n)
	{
		if (n < 0)
			throw 1;
		a = new float[n];
		for (int i = 0; i < n; i++)
		{
			a[i] = 0;
		}
	}
	void vypis()
	{
		for (int i = 0; i < n; i++)
		{
			cout << a[i] << " ";
		}
		cout << endl;
	}
	~Vector()
	{
		delete[] a;
	}
};

int main()
{
	{
		Vector v(3);
		v.vypis();
	}
	Zamestnanec1 jana;
	jana.vypis();

	{
		Zamestnanec1 x("Xx", "Yy", 25000);
		x.vypis();

		Zamestnanec1 z("Xx1", "Yy1");
		z.vypis();

	}
	//Zamestnanec1 *ux = new Zamestnanec1;
	Zamestnanec1 *ux = new Zamestnanec1();
	ux->vypis();
	delete ux;

	ux = new Zamestnanec1("Aa","Bb",45000);
	ux->vypis();
	delete ux;

	jana.nastavJmeno("Jana");
	jana.nastavPrijmeni("Novakova");
	jana.nastavPlat(20000);
	jana.vypis();
	vypis(jana);

	cout << premie(jana) << endl;
	//jana.jmeno = "Jana"; // nelze!

	return 0;
}